P=phantom(512); % Bild von Shepp-Logan-Phantom mit 256^2 Pixel
%imread()
figure
imshow(P) 
% imshow(P,[])  % [] skaliert Grauwerte auf min/max der gegebenen Werte in
% der Grauwert-Matrix
%%
theta=0:180; % Winkel
[R,s]=radon(P,theta); % Radontransformation von P, s-Achse
figure
iptsetpref('ImshowAxesVisible','on')
imshow(R,[],'Xdata',theta,'Ydata',s)
xlabel('\theta (grad)')
ylabel('s')

%%
% Fixer Winkel:
iptsetpref('ImshowAxesVisible','off')
theta1=45;
[R1,s1]=radon(P,theta1);

figure
plot(R1)
%imshow(R1,[],'Xdata',[45 45],'Ydata',s1)

%%
%%% Inversion:

I1=iradon(R,theta,'linear','none');  % Inverse Radontransformation ungefiltert
%I1=iradon(R,theta); % gefiltert
figure
imshow(I1,[])
% imshow(I1)   % bessere darstellung gefiltertes
%%
%%% Mit Störung

e=randn(size(R))*3; % Normalverteilte Matrix als Störung
Rs=R+e; % Radontransformierte wird gestört durch die Matrix
figure
iptsetpref('ImshowAxesVisible','on')
imshow(Rs,[],'Xdata',theta,'Ydata',s)
xlabel('\theta (grad)')
ylabel('s')
%%
iptsetpref('ImshowAxesVisible','off')
I2=iradon(Rs,theta);
figure
imshow(I2)
%%
% Inversion für spezielle Winkel
I3=iradon([R1 R1], [45 45])/2; % 45 Grad-Rückprojektion vom 45° Schnitt R1
figure
imshow(I3,[])
